import java.io.InputStream;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;

import lancs.mobilemedia.core.ui.datamodel.MediaData;
import lancs.mobilemedia.core.ui.datamodel.MusicAlbumData;
import lancs.mobilemedia.core.ui.screens.AddMediaToAlbum;
import lancs.mobilemedia.core.ui.screens.AlbumListScreen;
import lancs.mobilemedia.core.ui.screens.PlayMediaScreen;
import lancs.mobilemedia.lib.exceptions.ImageNotFoundException;
import lancs.mobilemedia.lib.exceptions.InvalidImageDataException;
import lancs.mobilemedia.lib.exceptions.PersistenceMechanismException;

class MediaController {

	public boolean handleCommand(Command command) {
		boolean handled = original(command);
		if (handled)
			return true;
		String label = command.getLabel();
		if (label.equals("Play")) {
			String selectedMediaName = getSelectedMediaName();
			return playMusicMedia(selectedMediaName);
		}
		return false;

	}

	private boolean saveItem() throws PersistenceMechanismException,
			InvalidImageDataException {
		original();
		try {
			if (getAlbumData() instanceof MusicAlbumData) {
				getAlbumData().loadMediaDataFromRMS(getCurrentStoreName());
				MediaData mymedia = getAlbumData().getMediaInfo(
						((AddMediaToAlbum) getCurrentScreen()).getItemName());
				mymedia.setTypeMedia(((AddMediaToAlbum) getCurrentScreen())
						.getItemType());
				getAlbumData().updateMediaInfo(mymedia, mymedia);
				// MultiMediaData mmedi = new MultiMediaData(mymedia,
				// ((AddMediaToAlbum) getCurrentScreen()).getItemType());
				// getAlbumData().updateMediaInfo(mymedia, mmedi);
			}

			return true;
		}
		catch (ImageNotFoundException e) {
			Alert alert = new Alert("Error",
					"The selected item was not found in the mobile device",
					null, AlertType.ERROR);
			Display.getDisplay(midlet).setCurrent(alert,
					Display.getDisplay(midlet).getCurrent());
			return true;
		}
	}

	private boolean playMusicMedia(String selectedMediaName) {
		InputStream storedMusic = null;
		try {
			MediaData mymedia = getAlbumData().getMediaInfo(selectedMediaName);
			// if (mymedia instanceof MultiMediaData) {
			if (mymedia.getTypeMedia().equals(MediaData.MUSIC)) {
				storedMusic = ((MusicAlbumData) getAlbumData())
						.getMusicFromRecordStore(getCurrentStoreName(),
								selectedMediaName);
				PlayMediaScreen playscree = new PlayMediaScreen(midlet,
						storedMusic, mymedia.getTypeMedia(), this);
				MusicPlayController controller = new MusicPlayController(
						midlet, getAlbumData(),
						(AlbumListScreen) getAlbumListScreen(), playscree);
				prepareController(controller, selectedMediaName);

				this.setNextController(controller);
			}
			return true;
		} catch (ImageNotFoundException e) {
			Alert alert = new Alert("Error",
					"The selected item was not found in the mobile device",
					null, AlertType.ERROR);
			Display.getDisplay(midlet).setCurrent(alert,
					Display.getDisplay(midlet).getCurrent());
			return false;
		} catch (PersistenceMechanismException e) {
			Alert alert = new Alert("Error",
					"The mobile database can open this item 1", null,
					AlertType.ERROR);
			Display.getDisplay(midlet).setCurrent(alert,
					Display.getDisplay(midlet).getCurrent());
			return false;
		}

	}
	private void prepareController(MusicPlayController controller, String name) {
		//nothing to prepare
	}
}
